/// <reference types="node" />
/// <reference types="ref-napi" />
import { BundleFile } from './BundleFile';
import { EndianReader } from './EndianReader';
import { BaseObject } from './Objects/BaseObject';
import { SerializedFile } from './SerializedFile';
export declare class AssetManager {
    protected readonly assetFiles: Map<string, SerializedFile>;
    protected readonly resourceFiles: Map<string, BundleFile>;
    readonly resourceFileReaders: Map<string, EndianReader>;
    readonly namedObjects: Map<string, BaseObject>;
    loadFiles(rootdir: string, assetDirGlobs: string[], assetGlobs: string[]): Promise<void>;
    loadFile(filePath: string, buffer?: Buffer, bundlePrefix?: string): Promise<void>;
    loadAssets(): void;
}
