/// <reference types="node" />
/// <reference types="ref-napi" />
import { EndianReader } from './EndianReader';
interface Size {
    compressed: number;
    uncompressed: number;
}
interface UnityFSHeader {
    signature: string;
    version: number;
    unityVersion: [verison: string, revision: string];
    blocksInfoSize: Size;
    size: bigint;
    flags: number;
}
export interface StreamFile {
    name: string;
    buffer: Buffer;
}
export declare class BundleFile {
    private readonly reader;
    private blocksStream;
    header: UnityFSHeader;
    private blocksInfo;
    files: StreamFile[];
    private constructor();
    static create(reader: EndianReader): Promise<BundleFile>;
    init(): Promise<void>;
    private readFiles;
    private readBlocksStream;
    private alignStream;
    private readBlocksInfo;
    private getBlocksInfoStream;
    private readHeader;
}
export {};
