/// <reference types="node" />
/// <reference types="ref-napi" />
import { SmartBuffer, SmartBufferOptions } from 'smart-buffer';
export declare enum EndianType {
    LE = 0,
    BE = 1
}
export interface EndianReaderOptions extends SmartBufferOptions {
    endianness?: EndianType;
}
export declare class EndianReader extends SmartBuffer {
    endianness: EndianType;
    constructor(options?: EndianReaderOptions);
    static fromBuffer(buff: Buffer): EndianReader;
    alignStream(alignment?: number): void;
    readAlignedString(): string;
    readArray<T extends keyof this>(method: T, count?: number): this[T] extends (offset?: number) => infer R ? R[] : never;
    readBoolean(offset?: number): boolean;
    readSingle(offset?: number): number;
    readInt16(offset?: number): number;
    readUInt16(offset?: number): number;
    readInt32(offset?: number): number;
    readUInt32(offset?: number): number;
    readInt64(offset?: number): bigint;
    readUInt64(offset?: number): bigint;
    readFloat(offset?: number): number;
    readDouble(offset?: number): number;
}
