import { BuildTarget } from './BuildTarget';
import { BuildType } from './BuildType';
import { ClassIDType } from './ClassIdType';
import { EndianReader } from './EndianReader';
import { ObjectInfo, SerializedFile } from './SerializedFile';
import { Version } from './VersionTuple';
export declare class ObjectReader extends EndianReader {
    readonly assetsFile: SerializedFile;
    readonly objectInfo: ObjectInfo;
    readonly version: Version;
    readonly buildType: BuildType;
    readonly fileVersion: number;
    readonly platform: BuildTarget;
    readonly classId: ClassIDType;
    readonly pathId: number | bigint;
    constructor(reader: EndianReader, assetsFile: SerializedFile, objectInfo: ObjectInfo);
    readObjectArray<T>(Type: {
        new (reader: ObjectReader): T;
    }): T[];
    readDelegatedArray<T>(delegate: (reader: ObjectReader) => T): T[];
    reset(): void;
}
