"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectReader = void 0;
const EndianReader_1 = require("./EndianReader");
class ObjectReader extends EndianReader_1.EndianReader {
    constructor(reader, assetsFile, objectInfo) {
        super({ buff: reader.internalBuffer, endianness: reader.endianness });
        this.assetsFile = assetsFile;
        this.objectInfo = objectInfo;
        this.version = assetsFile.version;
        this.buildType = assetsFile.buildType;
        this.fileVersion = assetsFile.header.version;
        this.platform = assetsFile.targetPlatform;
        this.classId = objectInfo.classId;
        this.pathId = objectInfo.pathId;
    }
    readObjectArray(Type) {
        const count = this.readInt32();
        const result = [];
        for (let n = 0; n < count; ++n) {
            result.push(new Type(this));
        }
        return result;
    }
    readDelegatedArray(delegate) {
        const count = this.readInt32();
        const result = [];
        for (let n = 0; n < count; ++n) {
            result.push(delegate(this));
        }
        return result;
    }
    reset() {
        this.readOffset = Number(this.objectInfo.byteStart);
    }
}
exports.ObjectReader = ObjectReader;
//# sourceMappingURL=ObjectReader.js.map