import { ObjectReader } from '../ObjectReader';
import { Vector3 } from './Vector';
export declare enum GfxPrimitiveType {
    kPrimitiveTriangles = 0,
    kPrimitiveTriangleStrip = 1,
    kPrimitiveQuads = 2,
    kPrimitiveLines = 3,
    kPrimitiveLineStrip = 4,
    kPrimitivePoints = 5
}
export declare class AABB {
    readonly center: Vector3;
    readonly extent: Vector3;
    constructor(reader: ObjectReader);
}
export declare class StreamInfo {
    readonly channelMask: number;
    readonly offset: number;
    readonly stride: number;
    readonly align?: number;
    readonly dividerOp?: number;
    readonly frequency?: number;
    constructor(reader: ObjectReader);
}
export declare class ChannelInfo {
    readonly stream: number;
    readonly offset: number;
    readonly format: number;
    readonly dimension: number;
    constructor(reader: ObjectReader);
}
export declare class BoneWeights4 {
    readonly weight: number[];
    readonly boneIndex: number[];
    constructor(reader: ObjectReader);
}
export declare class VertexData {
    readonly currentChannels?: number;
    readonly vertexCount: number;
    readonly channels?: ChannelInfo[];
    readonly streams?: StreamInfo[];
    readonly dataSize: number[];
    constructor(reader: ObjectReader);
}
export declare class SubMesh {
    readonly firstByte: number;
    readonly indexCount: number;
    readonly topology: GfxPrimitiveType;
    readonly triangleCount?: number;
    readonly baseVertex?: number;
    readonly firstVertex?: number;
    readonly vertexCount?: number;
    readonly localAABB: any;
    constructor(reader: ObjectReader);
}
