"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createObject = exports.TypeMap = void 0;
const ClassIdType_1 = require("../ClassIdType");
const BaseObject_1 = require("./BaseObject");
const NamedObject_1 = require("./NamedObject");
const Sprite_1 = require("./Sprite");
const Texture2D_1 = require("./Texture2D");
exports.TypeMap = {
    [ClassIdType_1.ClassIDType.Sprite]: Sprite_1.Sprite,
    [ClassIdType_1.ClassIDType.Texture]: Texture2D_1.Texture,
    [ClassIdType_1.ClassIDType.Texture2D]: Texture2D_1.Texture2D,
    [ClassIdType_1.ClassIDType.NamedObject]: NamedObject_1.NamedObject,
};
function createObject(classId, reader) {
    var _a;
    return new ((_a = exports.TypeMap[classId]) !== null && _a !== void 0 ? _a : BaseObject_1.BaseObject)(reader);
}
exports.createObject = createObject;
//# sourceMappingURL=index.js.map