"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unmakeVersion = exports.makeVersion = void 0;
const ts_brand_1 = require("ts-brand");
const _makeVersion = ts_brand_1.make();
function makeVersion(...tuple) {
    var _a, _b, _c, _d;
    const version = (BigInt((_a = tuple[0]) !== null && _a !== void 0 ? _a : 0) << BigInt(32)) |
        (BigInt((_b = tuple[1]) !== null && _b !== void 0 ? _b : 0) << BigInt(16)) |
        (BigInt((_c = tuple[2]) !== null && _c !== void 0 ? _c : 0) << BigInt(8)) |
        BigInt((_d = tuple[3]) !== null && _d !== void 0 ? _d : 0);
    return _makeVersion(version);
}
exports.makeVersion = makeVersion;
function unmakeVersion(version) {
    // can't do bitmasks on bigint, so encode to hex and split it that way
    const versionHex = version.toString(16).padStart(16, '0');
    return [
        parseInt(versionHex.substr(0, 8), 16),
        parseInt(versionHex.substr(10, 2), 16),
        parseInt(versionHex.substr(12, 2), 16),
        parseInt(versionHex.substr(14, 2), 16),
    ];
}
exports.unmakeVersion = unmakeVersion;
//# sourceMappingURL=VersionTuple.js.map