/// <reference types="node" />
/// <reference types="ref-napi" />
export interface Serializer<T> {
    stringify(target: T): string | NodeJS.ReadableStream | Buffer;
    parse(value: string | NodeJS.ReadableStream | Buffer): T;
}
export declare function setCacheDir(dir?: string): void;
export declare class Cache<T = NodeJS.ReadableStream> {
    private name;
    private fetch;
    private serializer?;
    private memCache;
    constructor(name: string, fetch: (key: string) => NodeJS.ReadableStream | Promise<NodeJS.ReadableStream>);
    constructor(name: string, fetch: (key: string) => T | Promise<T>, serializer?: Serializer<T>);
    get(key: string, cachedOnly?: boolean): Promise<T>;
    get(key: string, cachedOnly: true): Promise<T | undefined>;
}
