"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stripAnsi = void 0;
function ansiRegex({ onlyFirst = false } = {}) {
    const pattern = [
        '[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:[a-zA-Z\\d]*(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)',
        '(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))',
    ].join('|');
    return new RegExp(pattern, onlyFirst ? undefined : 'g');
}
function stripAnsi(value) {
    if (typeof value !== 'string') {
        throw new TypeError(`Expected a \`string\`, got \`${typeof value}\``);
    }
    return value.replace(ansiRegex(), '');
}
exports.stripAnsi = stripAnsi;
//# sourceMappingURL=StripAnsi.js.map